[Koha-patches] [PATCH] Bug 11509: koha-create should print better usage information

Tomas Cohen Arazi tomascohen at gmail.com
Thu Jan 9 16:50:39 CET 2014


This patch makes koha-create print better and more descriptive usage
information. Also adds the --help and -h switches.

Regards
To+

Sponsored-by: Universidad Nacional de Cordoba
---
 debian/docs/koha-create.xml | 10 +++++++
 debian/scripts/koha-create  | 67 ++++++++++++++++++++++++++++++++++-----------
 2 files changed, 61 insertions(+), 16 deletions(-)

diff --git a/debian/docs/koha-create.xml b/debian/docs/koha-create.xml
index 99ce191..ae046ce 100644
--- a/debian/docs/koha-create.xml
+++ b/debian/docs/koha-create.xml
@@ -37,6 +37,8 @@
       <arg><option>--passwdfile</option> /path/to/passwd</arg>
       <arg><option>--database</option> database</arg>
       <arg><option>--adminuser</option> n</arg>
+      <arg><option>--help</option>|<option>-h</option></arg>
+   
       <arg choice="req" rep="norepeat"><replaceable>instancename</replaceable></arg>
     </cmdsynopsis>
   </refsynopsisdiv>
@@ -149,6 +151,14 @@
       </listitem>
     </varlistentry>
 
+    <varlistentry>
+      <term><option>--help</option>,<option>-h</option></term>
+      <listitem>
+        <para>Print usage information.</para>
+      </listitem>
+    </varlistentry>
+
+
   </variablelist>
   </refsect1>
 
diff --git a/debian/scripts/koha-create b/debian/scripts/koha-create
index 7f05eb0..c0eecd2 100755
--- a/debian/scripts/koha-create
+++ b/debian/scripts/koha-create
@@ -19,15 +19,49 @@
 
 set -e
 
-usage="Usage: $0 [--create-db|--request-db|--populate-db|--use-db] \
-    [--marcflavor marc21|normarc|unimarc] \
-    [--zebralang en|es|fr|nb|ru|uk] \
-    [--auth-idx dom|grs1] [--biblio-idx dom|grs1] \
-    [--use-memcached] \
-    [--memcached-servers server:port] [--memcached-prefix prefix] \
-    [--defaultsql /path/to/some.sql] \
-    [--configfile /path/to/config] [--passwdfile /path/to/passwd] \
-    [--database database] [--adminuser n] instancename"
+usage()
+{
+    local scriptname=$0
+    cat <<EOF
+
+Creates new Koha instances.
+
+Usage:
+
+  $scriptname [db usage mode] [options] instancename"
+
+DB usage mode:
+  --create-db               Create a new database on localhost. (default).
+  --request-db              Creates a instancename-db-request.txt file where
+                            you adjust your DB settings and re-run with --populate-db.
+  --populate-db             Finish the installation you started with --request-db after
+                            you adjusted the instancename-db-request.txt file.
+  --use-db                  Use this option if you already created and populated you DB.
+
+Options:
+  --marcflavor flavor       Set the MARC flavor. Valid values are marc21 (default),
+                            normarc and unimarc.
+  --zebralang lang          Choose the primary language for Zebra indexing. Valid
+                            values are en (default), es, fr, nb, ru and uk.
+  --auth-idx idx_mode       Set the indexing mode for authority records. Valid
+                            values are dom (default) and grs1.
+  --biblio-idx idx_mode     Set the indexing mode for bibliographic records.
+                            Valid values are dom (default) and grs1.
+  --use-memcached           Set the instance to make use of memcache.
+  --memcached-servers str   Set a comma-separated list of host:port memcached servers.
+  --memcached-prefix str    Set the desired prefix for the instance memcached namespace.
+  --defaultsql some.sql     Specify a default SQL file to be loaded on the DB.
+  --configfile cfg_file     Specify an alternate config file for reading default values.
+  --passwdfile passwd       Specify an alternate passwd file.
+  --database dbname         Enforce the use of the specified DB name (64 char limit)
+  --adminuser n             Explicit the admin user ID in the DB. Relevant in
+                            conjunction with --defaultsql and --populate-db.
+  --help,-h                 Show this help.
+
+Note: the instance name cannot be longer that 11 chars.
+
+EOF
+}
 
 die() {
     echo "$@" 1>&2
@@ -220,9 +254,9 @@ then
     . /etc/koha/koha-sites.conf
 fi
 
-[ $# -ge 2 ] && [ $# -le 16 ] || die $usage
+[ $# -ge 2 ] && [ $# -le 16 ] || ( usage ; die "Error: wrong parameters" )
 
-TEMP=`getopt -o crpm:l:d:f:b:a: -l create-db,request-db,populate-db,use-db,use-memcached,marcflavor:,auth-idx:,biblio-idx:,zebralang:,defaultsql:,configfile:,passwdfile:,database:,adminuser:,memcached-servers:,memcached-prefix:, \
+TEMP=`getopt -o chrpm:l:d:f:b:a: -l create-db,request-db,populate-db,use-db,use-memcached,help,marcflavor:,auth-idx:,biblio-idx:,zebralang:,defaultsql:,configfile:,passwdfile:,database:,adminuser:,memcached-servers:,memcached-prefix:, \
      -n "$0" -- "$@"`
 
 # Note the quotes around `$TEMP': they are essential!
@@ -257,11 +291,11 @@ while true ; do
             CLO_MEMCACHED_PREFIX="$2" ; shift 2;;
         -m|--marcflavor)
             CLO_ZEBRA_MARC_FORMAT="$2" ; shift 2 ;;
-    -l|--zebralang)
+        -l|--zebralang)
             CLO_ZEBRA_LANGUAGE="$2" ; shift 2 ;;
-    --auth-idx)
+        --auth-idx)
             CLO_AUTHORITIES_INDEXING_MODE="$2" ; shift 2 ;;
-    --biblio-idx)
+        --biblio-idx)
             CLO_BIBLIOS_INDEXING_MODE="$2" ; shift 2 ;;
         -d|--defaultsql)
             CLO_DEFAULTSQL="$2" ; shift 2 ;;
@@ -273,6 +307,8 @@ while true ; do
             CLO_DATABASE="$2" ; shift 2 ;;
         -a|--adminuser)
             CLO_ADMINUSER="$2" ; shift 2 ;;
+        -h|--help)
+            usage ; exit 0 ;;
         --)
             shift ; break ;;
         *)
@@ -341,8 +377,7 @@ Please set USE_MEMCACHED="yes" on /etc/koha/koha-sites.conf or use the
 
 EOF`
 
-    echo $usage
-    die $MSG
+    usage ; die $MSG
 else
     # Unset memcached-related variables
     MEMCACHED_SERVERS=""
-- 
1.8.5.2



More information about the Koha-patches mailing list